commit 0cf5f1656eff31bcc1131ca047030f4866b4224b
Author: Jeremy Harris <jgh146exb@wizmail.org>
Date:   Fri Nov 7 17:50:28 2025 +0000

    Retire "pwcheck" expansion condition

diff --git a/src/OS/Makefile-Base b/src/OS/Makefile-Base
index e24ef95f2..25a8e82a7 100644
--- a/src/OS/Makefile-Base
+++ b/src/OS/Makefile-Base
@@ -552,8 +552,7 @@ OBJ_LOOKUPS = lf_quote.o lf_check_file.o lf_sqlperform.o
 OBJ_ROUTERS = rf_change_domain.o rf_expand_data.o rf_get_errors_address.o \
 	rf_get_munge_headers.o rf_get_transport.o rf_get_ugid.o \
 	rf_lookup_hostlist.o rf_queue_add.o rf_self_action.o rf_set_ugid.o
-OBJ_AUTHS = call_pwcheck.o check_serv_cond.o \
-	get_data.o get_no64_data.o pwcheck.o
+OBJ_AUTHS = check_serv_cond.o get_data.o get_no64_data.o pwcheck.o
 
 OBJ_EXIM = acl.o atrn.o base64.o child.o crypt16.o daemon.o dbfn.o debug.o \
 	deliver.o directory.o dns.o drtables.o enq.o exim.o expand.o \
@@ -1003,9 +1002,6 @@ rf_set_ugid.o:           routers/rf_set_ugid.c
 auth-spa.o:         auths/auth-spa.c
 	@echo "$(CC) $<"
 	$(FE)$(CC) -c $(CFLAGS) -I. $(INCLUDE) $<
-call_pwcheck.o:     auths/call_pwcheck.c auths/pwcheck.h
-	@echo "$(CC) $<"
-	$(FE)$(CC) -c $(CFLAGS) -I. $(INCLUDE) $<
 check_serv_cond.o:  auths/check_serv_cond.c
 	@echo "$(CC) $<"
 	$(FE)$(CC) -c $(CFLAGS) -I. $(INCLUDE) $<
diff --git a/src/scripts/MakeLinks b/src/scripts/MakeLinks
index 8f55be0b5..765472195 100755
--- a/src/scripts/MakeLinks
+++ b/src/scripts/MakeLinks
@@ -78,7 +78,7 @@ d="auths"
 mkdir $d
 cd $d
 # Makefile is generated
-for f in README call_pwcheck.c \
+for f in README \
   check_serv_cond.c cyrus_sasl.c cyrus_sasl.h gsasl.c \
   gsasl.h get_data.c get_no64_data.c heimdal_gssapi.c heimdal_gssapi.h \
   cram_md5.c cram_md5.h plaintext.c plaintext.h \
diff --git a/src/src/EDITME b/src/src/EDITME
index 998406359..d38ac98e5 100644
--- a/src/src/EDITME
+++ b/src/src/EDITME
@@ -1205,23 +1205,6 @@ ZCAT_COMMAND=/usr/bin/zcat
 # using the original API.
 
 
-#------------------------------------------------------------------------------
-# Support for authentication via the Cyrus SASL pwcheck daemon is available.
-# Note, however, that pwcheck is now deprecated in favour of saslauthd (see
-# next item). The Exim support for pwcheck, which is intented for use in
-# conjunction with the SMTP AUTH facilities, is included only when requested by
-# setting the following parameter to the location of the pwcheck daemon's
-# socket.
-#
-# There is no need to install all of SASL on your system. You just need to run
-# ./configure --with-pwcheck, cd to the pwcheck directory within the sources,
-# make and make install. You must create the socket directory (default
-# /var/pwcheck) and chown it to Exim's user and group. Once you have installed
-# pwcheck, you should arrange for it to be started by root at boot time.
-
-# CYRUS_PWCHECK_SOCKET=/var/pwcheck/pwcheck
-
-
 #------------------------------------------------------------------------------
 # Support for authentication via the Cyrus SASL saslauthd daemon is available.
 # The Exim support, which is intended for use in conjunction with the SMTP AUTH
diff --git a/src/src/auths/pwcheck.c b/src/src/auths/pwcheck.c
index bf305832f..cd8ed1e10 100644
--- a/src/src/auths/pwcheck.c
+++ b/src/src/auths/pwcheck.c
@@ -59,16 +59,16 @@
  */
 
 /* Originally this module supported only the pwcheck daemon, which is where its
-name comes from. Nowadays it supports saslauthd as well; pwcheck is in fact
-deprecated. The definitions of CYRUS_PWCHECK_SOCKET and CYRUS_SASLAUTHD_SOCKET
-determine whether the facilities are actually supported or not. */
+name comes from. Nowadays it supports saslauthd instead; pwcheck is in fact
+deprecated. The definition of CYRUS_SASLAUTHD_SOCKET
+determines whether the facilities are actually supported or not. */
 
 
 #include "../exim.h"
 #include "pwcheck.h"
 
 
-#if defined(CYRUS_PWCHECK_SOCKET) || defined(CYRUS_SASLAUTHD_SOCKET)
+#if defined(CYRUS_SASLAUTHD_SOCKET)
 
 #include <sys/uio.h>
 
@@ -80,79 +80,6 @@ static int write_string(int, const uschar *, int);
 #endif
 
 
-/* A dummy function that always fails if pwcheck support is not
-wanted. */
-
-#ifndef CYRUS_PWCHECK_SOCKET
-int pwcheck_verify_password(const char *userid,
-                            const char *passwd,
-                            const char **reply)
-{
-*reply = "pwcheck support is not included in this Exim binary";
-return PWCHECK_FAIL;
-}
-
-
-/* This is the real function */
-
-#else
-
- /* taken from cyrus-sasl file checkpw.c */
- /* pwcheck daemon-authenticated login */
- int pwcheck_verify_password(const char *userid,
-                                  const char *passwd,
-                                  const char **reply)
- {
-     int s, start, r, n;
-     struct sockaddr_un srvaddr;
-     struct iovec iov[2];
-     static char response[1024];
-
-     *reply = NULL;
-
-     s = socket(AF_UNIX, SOCK_STREAM, 0);
-     if (s == -1) { return PWCHECK_FAIL; }
-
-     memset(CS &srvaddr, 0, sizeof(srvaddr));
-     srvaddr.sun_family = AF_UNIX;
-     strncpy(srvaddr.sun_path, CYRUS_PWCHECK_SOCKET, sizeof(srvaddr.sun_path));
-     r = connect(s, (struct sockaddr *)&srvaddr, sizeof(srvaddr));
-     if (r == -1) {
-        DEBUG(D_auth)
-            debug_printf("Cannot connect to pwcheck daemon (at '%s')\n",CYRUS_PWCHECK_SOCKET);
-       *reply = "cannot connect to pwcheck daemon";
-       return PWCHECK_FAIL;
-     }
-
-     iov[0].iov_base = CS userid;
-     iov[0].iov_len = strlen(userid)+1;
-     iov[1].iov_base = CS passwd;
-     iov[1].iov_len = strlen(passwd)+1;
-
-     retry_writev(s, iov, 2);
-
-     start = 0;
-     while (start < sizeof(response) - 1) {
-       n = read(s, response+start, sizeof(response) - 1 - start);
-       if (n < 1) break;
-       start += n;
-     }
-
-     (void)close(s);
-
-     if (start > 1 && !strncmp(response, "OK", 2)) {
-       return PWCHECK_OK;
-     }
-
-     response[start] = '\0';
-     *reply = response;
-     return PWCHECK_NO;
- }
-
-#endif
-
-
-
  /* A dummy function that always fails if saslauthd support is not
 wanted. */
 
@@ -268,7 +195,7 @@ int saslauthd_verify_password(const uschar *userid,
 
 
 /* helper functions */
-#if defined(CYRUS_PWCHECK_SOCKET) || defined(CYRUS_SASLAUTHD_SOCKET)
+#if defined(CYRUS_SASLAUTHD_SOCKET)
 
 #define MAX_REQ_LEN 1024
 
diff --git a/src/src/auths/pwcheck.h b/src/src/auths/pwcheck.h
index 4c1d71d92..0c20292ce 100644
--- a/src/src/auths/pwcheck.h
+++ b/src/src/auths/pwcheck.h
@@ -6,8 +6,8 @@
 /* See the file NOTICE for conditions of use and distribution. */
 /* SPDX-License-Identifier: GPL-2.0-or-later */
 
-/* This file provides support for authentication via the Cyrus SASL pwcheck
-daemon (whence its name) and the newer saslauthd daemon. */
+/* This file originally provided support for authentication via the Cyrus
+SASL pwcheck daemon (whence its name), but now the newer saslauthd daemon. */
 
 /* Error codes used internally within the authentication functions */
 
@@ -21,7 +21,6 @@ daemon (whence its name) and the newer saslauthd daemon. */
 
 /* Cyrus functions for doing the business. */
 
-extern int pwcheck_verify_password(const char *, const char *, const char **);
 extern int saslauthd_verify_password(const uschar *, const uschar *,
            const uschar *, const uschar *, const uschar **);
 
diff --git a/src/src/config.h.defaults b/src/src/config.h.defaults
index 05bdcd6d3..f331ad0d5 100644
--- a/src/src/config.h.defaults
+++ b/src/src/config.h.defaults
@@ -40,7 +40,6 @@ Do not put spaces between # and the 'define'.
 #define CONFIGURE_FILE_USE_NODE
 #define CONFIGURE_GROUP
 #define CONFIGURE_OWNER
-#define CYRUS_PWCHECK_SOCKET
 #define CYRUS_SASLAUTHD_SOCKET
 
 #define DEFAULT_CRYPT              crypt
diff --git a/src/src/exim.c b/src/src/exim.c
index c6fa25fc7..9d6f858bd 100644
--- a/src/src/exim.c
+++ b/src/src/exim.c
@@ -1158,9 +1158,6 @@ g = string_cat(g, US"Support for:");
 #ifdef USE_OPENSSL
   g = string_cat(g, US" OpenSSL");
 #endif
-#if defined(CYRUS_PWCHECK_SOCKET)
-  g = string_cat(g, US" pwcheck");
-#endif
 #if defined(RADIUS_CONFIG_FILE)
   g = string_cat(g, US" radius");
 #endif
diff --git a/src/src/expand.c b/src/src/expand.c
index 9bfa39fdc..fb32ce985 100644
--- a/src/src/expand.c
+++ b/src/src/expand.c
@@ -362,7 +362,6 @@ static uschar *cond_table[] = {
   US"match_local_part",
   US"or",
   US"pam",
-  US"pwcheck",
   US"queue_running",
   US"radius",
   US"saslauthd"
@@ -415,7 +414,6 @@ enum {
   ECOND_MATCH_LOCAL_PART,
   ECOND_OR,
   ECOND_PAM,
-  ECOND_PWCHECK,
   ECOND_QUEUE_RUNNING,
   ECOND_RADIUS,
   ECOND_SASLAUTHD
@@ -2740,7 +2738,6 @@ switch(cond_type = identify_operator(&s, &opname))
   case ECOND_PAM:
   case ECOND_RADIUS:
   case ECOND_LDAPAUTH:
-  case ECOND_PWCHECK:
 
   if (Uskip_whitespace(&s) != '{') goto COND_FAILED_CURLY_START; /* }-for-text-editors */
 
@@ -2835,16 +2832,8 @@ switch(cond_type = identify_operator(&s, &opname))
     goto COND_FAILED_NOT_COMPILED;
     #endif  /* LOOKUP_LDAP */
 
-    case ECOND_PWCHECK:
-    #ifdef CYRUS_PWCHECK_SOCKET
-    rc = auth_call_pwcheck(sub[0], &expand_string_message);
-    goto END_AUTH;
-    #else
-    goto COND_FAILED_NOT_COMPILED;
-    #endif  /* CYRUS_PWCHECK_SOCKET */
-
     #if defined(SUPPORT_PAM) || defined(RADIUS_CONFIG_FILE) || \
-        defined(LOOKUP_LDAP) || defined(CYRUS_PWCHECK_SOCKET)
+        defined(LOOKUP_LDAP)
     END_AUTH:
     if (rc == ERROR || rc == DEFER) goto failout;
     *yield = (rc == OK) == testfor;
@@ -3724,7 +3713,7 @@ goto failout;
 /* A condition requires code that is not compiled */
 
 #if !defined(SUPPORT_PAM) || !defined(RADIUS_CONFIG_FILE) || \
-    !defined(LOOKUP_LDAP) || !defined(CYRUS_PWCHECK_SOCKET) || \
+    !defined(LOOKUP_LDAP) || \
     !defined(SUPPORT_CRYPTEQ) || !defined(CYRUS_SASLAUTHD_SOCKET)
 COND_FAILED_NOT_COMPILED:
 expand_string_message = string_sprintf("support for %q not compiled",
diff --git a/src/src/functions.h b/src/src/functions.h
index ef1c59dc3..bd390cce6 100644
--- a/src/src/functions.h
+++ b/src/src/functions.h
@@ -112,7 +112,6 @@ extern void    assert_no_variables(void *, int, const char *, int);
 extern void    atrn_handle_customer(void);
 extern int     atrn_handle_provider(uschar **, uschar **);
 
-extern int     auth_call_pwcheck(uschar *, uschar **);
 extern int     auth_call_saslauthd(const uschar *, const uschar *,
 	         const uschar *, const uschar *, uschar **);
 extern int     auth_check_serv_cond(auth_instance *);

